import 'dart:async';

import 'package:dio/dio.dart';
import 'package:flutter/foundation.dart';

import 'dio_http.dart';
import 'dio_request.dart';

///
/// author：Vans Z
/// date： 2019/1/13 0013
///

class DioCall {
  DioRequest request;

  DioCall(this.request);

  Future<Response> execute() async {
    var dioHttp = request.dioHttp;
    var dio = dioHttp.getDioClient();

    request.tag ??= DioHttp.defaultTag;
    dioHttp.tokenMap[request.tag!] = request.cancelToken;
    if (request.headerMap != null) {
      dio.options.headers = request.headerMap;
    }
    if (dioHttp.commonParams != null && dioHttp.commonParams!.isNotEmpty) {
      if (request.params != null) {
        request.params.addAll(dioHttp.commonParams);
      } else {
        request.params = dioHttp.commonParams;
      }
    }
    debugPrint('DioHttp--------------------------START---------------------------');
    request.log();
    Response result;
    try {
      result = await request.callRequest(dio);
    } on DioError catch (e) {
      debugPrint('DioHttp error message: ${e.message}');
      if (e.response != null) {
        debugPrint('DioHttp error data: ${e.response?.data}');
      }
      rethrow;
    }
    debugPrint('DioHttp response: $result');
    debugPrint('DioHttp---------------------------END---------------------------');
    return result;
  }
}
