class PayPriceEntity {
  late List<PayPricePriceList>? priceList;

  PayPriceEntity({required this.priceList});

  PayPriceEntity.fromJson(Map<String, dynamic> json) {
    if (json['price_list'] != null) {
      priceList = <PayPricePriceList>[];
      (json['price_list'] as List).forEach((v) {
        priceList?.add(PayPricePriceList.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    if (priceList != null) {
      data['price_list'] = priceList?.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class PayPricePriceList {
  late String price;
  late PayPricePriceListSubscription? subscription;
  late String sku;

  PayPricePriceList({required this.price, required this.subscription, required this.sku});

  PayPricePriceList.fromJson(Map<String, dynamic> json) {
    price = json['price'];
    subscription = json['subscription'] != null
        ? PayPricePriceListSubscription.fromJson(json['subscription'])
        : null;
    sku = json['sku'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['price'] = price;
    if (subscription != null) {
      data['subscription'] = subscription?.toJson();
    }
    data['sku'] = sku;
    return data;
  }
}

class PayPricePriceListSubscription {
  late int period;
  late String periodType;

  PayPricePriceListSubscription({required this.period, required this.periodType});

  PayPricePriceListSubscription.fromJson(Map<String, dynamic> json) {
    period = json['period'];
    periodType = json['period_type'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['period'] = period;
    data['period_type'] = periodType;
    return data;
  }
}
