import 'dart:convert';

import 'package:fgx_super_pay/dio/dio_http.dart';
import 'package:fgx_super_pay/model/entity/pay_package_entity.dart';
import 'package:fgx_super_pay/model/local_storage.dart';

import 'constant.dart';
import 'entity/pay_price_entity.dart';

///
/// author：Vans Z
/// date： 2019-09-16
///

class PayResource with DioHttp {

  Future<PayPackageEntity> getPackageRes(String packageUrl) async{
    var historyPackages = await localStorage.getItem(packageListKey);
    if (historyPackages == null) {
      return await loadPackageRes(packageUrl);
    } else {
      loadPackageRes(packageUrl);
      return PayPackageEntity.fromJson(jsonDecode(historyPackages));
    }
  }

  Future<PayPackageEntity> loadPackageRes(String packageUrl) async {
    var resultPackages;
    try {
      var response = await get(packageUrl).build().execute();
      resultPackages = PayPackageEntity.fromJson({"pay_package_list": response.data});
      localStorage.setItem(packageListKey, resultPackages);
    } catch (_) {
      var historyPackages = await localStorage.getItem(packageListKey);
      resultPackages = PayPackageEntity.fromJson(jsonDecode(historyPackages));
    }
    return resultPackages;
  }

  Future<PayPriceEntity> loadPriceRes(String priceUrl) async {
    var resultPrices;
    try {
      var response = await get(priceUrl).build().execute();
      resultPrices = PayPriceEntity.fromJson({"price_list": response.data});
      localStorage.setItem(priceListKey, resultPrices);
    } catch (_) {
      var historyPrices = await localStorage.getItem(priceListKey);
      resultPrices = PayPriceEntity.fromJson(historyPrices);
    }
    return resultPrices;
  }
}
